﻿/////////////////////////////////////////////////////////////////////////////////////////
//                                                                                     //
// RSSTicker gadget © Richard Williams 2010                                            //
//                                                                                     //
///////////////////////////////////////////////////////////////////////////////////////// 
var scrollSpeed;
var refreshSpeed; 
var refresh; 
var streamer = new Array();
var msg = "";
var shortMessage = 20;
var longMessage = 90;
var smallFont = "8pt";
var largeFont = "10pt";
var msgLength = shortMessage;
var displayLinks = false;
var scrollTimer;
var rssTitle;
var rssDescription;
var rssLink;
var rssDetails;
var rssURL;
var currentURL;
var counter = -1;
function checkSettings(){
	// If any of the settings are invalid, reset to the system defaults
    rssURL = System.Gadget.Settings.readString("rssURL");
	if(rssURL == ""){
	    rssURL = "http://newsrss.bbc.co.uk/rss/newsonline_uk_edition/front_page/rss.xml";
		System.Gadget.Settings.writeString("rssURL",rssURL);
	}else{
	    if(rssURL.substring(0,7) != "http://"){
		    rssURL = "http://"+rssURL;
		}
	}
	currentURL = rssURL;
	scrollSpeed = System.Gadget.Settings.readString("scrollSpeed");
	if(scrollSpeed == "" || scrollSpeed == " " || scrollSpeed == 0 || isNaN(scrollSpeed)){
	    scrollSpeed=350;
		System.Gadget.Settings.writeString("scrollSpeed",scrollSpeed);
	}
	refreshSpeed = System.Gadget.Settings.readString("refreshSpeed");
	if(refreshSpeed == "" || refreshSpeed == " " || refreshSpeed == 0 || isNaN(refreshSpeed)){
        refreshSpeed = 5;
        System.Gadget.Settings.writeString("refreshSpeed",refreshSpeed);
	}	
	refresh = Math.round((refreshSpeed*60*1000)/scrollSpeed);
}
function makeStreamer(){
	// Extract the relevant information from the RSS feed.  The item titles are put into a long string, separated by •
	// The item links are put into an array that connect back to the title by counting the number of •'s
	// **start**  in the string resets the counter.
	//
	// If it seems that the supplied URL is not an RSS feed, that the function resturns false.
	//
	msg = "**start** ";
	var xmlDoc = new ActiveXObject("Microsoft.XMLDOM");
	xmlDoc.async = "false";
	xmlDoc.load(rssURL);
    if (xmlDoc.parseError.errorCode != 0) return false;
	var isRSS = xmlDoc.getElementsByTagName("channel");
	if(isRSS.length == 0)return false;
	var channel = xmlDoc.getElementsByTagName("channel").item(0);
	rssTitle = channel.getElementsByTagName("title");
	rssDescription = channel.getElementsByTagName("description");
	rssLink = channel.getElementsByTagName("link");
	rssDetails = "<a href='"+rssLink.item(0).text+"'>"+rssTitle.item(0).text+"</a>&nbsp;"+rssDescription.item(0).text;
	rssDetails = rssDetails.substring(0,longMessage+11+rssLink.item(0).text.length);
	var items = channel.getElementsByTagName("item");
	if(items.length==0)return false;
	for(i=0;i<items.length;i++){
		var thisItem = items.item(i);
		var itemTitle = thisItem.getElementsByTagName("title");
		var itemDate = thisItem.getElementsByTagName("pubDate");
		var itemLink = thisItem.getElementsByTagName("link");
		streamer[i] = "<a href='"+itemLink.item(0).text+"'>"+itemTitle.item(0).text+"</a> "+itemDate.item(0).text;
		msg+= "•"+" "+itemTitle.item(0).text+" ";
	}
	return true;
}
function scrollText() {
	// This scrolls the message forward 1 character at a time and sets a timeout to call itself after the scrollSpeed interval.
	//
	// This is also where the •'s are counted.
	//
	scrollTimer = window.setTimeout('scrollText()',scrollSpeed);
	msg = msg.substring(1)+msg.substring(0,1);
	if(msg.charCodeAt(0) == 8226){
		counter = counter+1;
	}
	msg1 = msg.substring(0,msgLength);
	if(msg.substring(0,10) == "**start** "){
		counter = -1;
	}
	showText(msg1);
	checkHeadline();
	
}
function checkHeadline(){
	// check for the • preceding each new headline
	// displayLinks true means that the gadget is undocked (larger size).
	refresh--;
	if(refresh <= 0){
		makeStreamer();
		refresh = Math.round((refreshSpeed*60*1000)/scrollSpeed);
		counter = -1;
		startStreamer();
	}
	if(displayLinks){
	    if(msg.charCodeAt(0) == 8226){
		    showLinks(streamer[counter]);
	    } 
		showDetails(rssDetails);
	}else{
    	showLinks("");
		showDetails("");
	}
} 
function startStreamer(){
	// Fill the fields with their initial values
	msg1 = msg.substring(0,msgLength);
	showText(msg1);
	if(displayLinks){
		if(counter!=-1)showLinks(streamer[counter]);
	}else showLinks("");
}
function init(){
	System.Gadget.settingsUI = "settings.html";
	System.Gadget.onDock = CheckDockState;
	System.Gadget.onUndock = CheckDockState;
	System.Gadget.onSettingsClosed = settingsClosed;
	initText();
	initLinks();
	initDetails();
	checkSettings();
}
function initText(){
    oText = document.getElementById("text");
}
function initLinks(){
    oLinks = document.getElementById("links");
}	
function showText(newValue){
    oText.innerHTML = newValue;
}
function showLinks(newValue){
    oLinks.innerHTML = newValue;
}
function initDetails(){
    oDetails = document.getElementById("details");
}
function showDetails(details){
    oDetails.innerHTML = details;
}
function CheckDockState(){
    var oBackground = document.getElementById("imgBackground");
    System.Gadget.beginTransition();
    
    var oBody = document.body.style;
	var oBGstyle = oBackground.style;
	var oText = document.getElementById("text").style;
    if (System.Gadget.docked)
    {
        oBody.width = 130;
        oBody.height = 80;
		oBGstyle.width = 130;
		oBGstyle.height = 80;
		oText.fontSize = smallFont;
		msgLength = shortMessage;
		displayLinks = false;
    }
    else
    {
        oBody.width = 570;
        oBody.height = 100; 
		oBGstyle.width = 570;
		oBGstyle.height = 100;
		oText.fontSize = largeFont;
        msgLength = longMessage;
		displayLinks = true;
    }
    System.Gadget.endTransition(System.Gadget.TransitionType.morph, 1);
}
function start(){
    // start the ticker running
	document.getElementById("start").disabled = true;
	document.getElementById("stop").disabled = false;
	if(makeStreamer()){
        startStreamer();
        scrollText();
	}else {
	    showText("<span style='color:red;'><b>Error - not RSS</b></span>");
	}
}
function stop(){
    // stop the ticker by cancelling the timeout.
	document.getElementById("start").disabled = false;
	document.getElementById("stop").disabled = true;
	window.clearTimeout(scrollTimer);
	showText("");
	showLinks("");
	showDetails("");
	counter = -1;
}
function settingsClosed(event){
	//  if the speed settings are changed, just carry on but the the new values.
	//  if the RSS Feed URL has changed, come to a Stop and wait for another Go
	if(event.closeAction == event.Action.commit){
		if(System.Gadget.Settings.readString("rssURL") != currentURL){
			stop();
		}
		init();
	}
	event.cancel = false;
}
window.onload = function(){
  init();
}